package death_cause

import (
	ecore "simrs-vx/internal/domain/base-entities/core"
)

type CreateDto struct {
	Encounter_Id *uint   `json:"-"`
	Value        *string `json:"value"`
}

type ReadListDto struct {
	FilterDto
	Includes   string `json:"includes"`
	Pagination ecore.Pagination
}

type FilterDto struct {
	Encounter_Id *uint `json:"encounter-id"`
}

type ReadDetailDto struct {
	Id uint16 `json:"id"`
}

type UpdateDto struct {
	Id uint16 `json:"id"`
	CreateDto
}

type DeleteDto struct {
	Id uint16 `json:"id"`
}

type MetaDto struct {
	PageNumber int `json:"page_number"`
	PageSize   int `json:"page_size"`
	Count      int `json:"count"`
}

type ResponseDto struct {
	ecore.Main
	Encounter_Id *uint   `json:"encounter_id"`
	Value        *string `json:"value"`
}

func (d DeathCause) ToResponse() ResponseDto {
	resp := ResponseDto{
		Encounter_Id: d.Encounter_Id,
		Value:        d.Value,
	}
	resp.Main = d.Main
	return resp
}

func ToResponseList(data []DeathCause) []ResponseDto {
	resp := make([]ResponseDto, len(data))
	for i, u := range data {
		resp[i] = u.ToResponse()
	}
	return resp
}
